-- Test change_password
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(14);

set search_path to camper, auth, public;

select has_function('camper', 'change_password', array ['text']);
select function_lang_is('camper', 'change_password', array ['text'], 'sql');
select function_returns('camper', 'change_password', array ['text'], 'void');
select is_definer('camper', 'change_password', array ['text']);
select volatility_is('camper', 'change_password', array ['text'], 'volatile');
select function_privs_are('camper', 'change_password', array ['text'], 'guest', array []::text[]);
select function_privs_are('camper', 'change_password', array ['text'], 'employee', array ['EXECUTE']);
select function_privs_are('camper', 'change_password', array ['text'], 'admin', array ['EXECUTE']);
select function_privs_are('camper', 'change_password', array ['text'], 'authenticator', array []::text[]);

set client_min_messages to warning;
truncate company_host cascade;
truncate company_user cascade;
truncate company cascade;
truncate auth."user" cascade;
reset client_min_messages;

insert into auth."user" (user_id, email, name, password, cookie, cookie_expires_at)
values (1, 'demo@tandem.blog', 'Demo', 'test', '44facbb30d8a419dfd4bfbc44a4b5539d4970148dfc84bed0e', current_timestamp + interval '1 month')
     , (9, 'admin@tandem.blog', 'Demo', 'test', '12af4c88b528c2ad4222e3740496ecbc58e76e26f087657524', current_timestamp + interval '1 month')
;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (2, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into company_user (company_id, user_id, role)
values (2, 1, 'employee')
     , (2, 9, 'admin')
;

insert into company_host (company_id, host)
values (2, 'localhost')
;

select lives_ok($$ select change_password('another') $$, 'Should run even without current user');

select isnt_empty(
	$$ select * from auth."user" where password = crypt('test', password) $$,
	'Should not have changed any password'
);

select set_cookie('44facbb30d8a419dfd4bfbc44a4b5539d4970148dfc84bed0e/demo@tandem.blog', 'localhost');

select lives_ok($$ select change_password('another') $$, 'Should run with the correct user');

reset role;

select isnt_empty(
	$$ select * from auth."user" where email = 'demo@tandem.blog' and password = crypt('another', password) $$,
	'Should have changed the password of the current user'
);

select isnt_empty(
	$$ select * from auth."user" where email = 'admin@tandem.blog' and password = crypt('test', password) $$,
	'Should not have changed any other password'
);

select *
from finish();

rollback;
